module Main where

import Control.Concurrent
import Control.Concurrent.Chan
import Control.Exception
import ProcManager
--
-- Need to find a way to send a list of values: 
--  -might have to use "atomic" and several send/receive
--  -or just send a list [a,b,c]? or tuple ?
--


main = do
  children <- newMVar [] -- synch
  s <- newChan
  t <- newChan
  forkChild children $ do -- A
         putStrLn "Starting A..."
         writeChan s "Hello, I am A"
         res <- readChan t
         putStrLn $ "RecFromB: "++res
         let body i = do writeChan s (show i)
                         sel <- readChan t
                         if (sel == "ending")
                          then putStrLn "A done."
                          else do writeChan s (show i)
                                  body (i-1)
         body 19
 
  forkChild children $ do -- B
        putStrLn "Starting B..."
        let s' = s 
        hs <- readChan s'
        putStrLn $ "RecFromA: "++hs
        writeChan t "Hello, I am B."
        let body = do t'' <- readChan s'
                      let tmp = read t''::Int
                      do
                            if ((tmp) == 0 )
                             then do
                              writeChan t "ending"
                              putStrLn "B Done."
                             else do
                              writeChan t "cont"
                              ss <- readChan s'
                              putStrLn $ ("Received: "++ ss)
                              body
        body

  waitForChildren children -- synch
  putStrLn "End."


